searchData={"items":[{"type":"module","title":"Pythonx","doc":"Documentation for `Pythonx`.","ref":"Pythonx.html"},{"type":"function","title":"Pythonx.eval/2","doc":"","ref":"Pythonx.html#eval/2"},{"type":"function","title":"Pythonx.eval!/2","doc":"","ref":"Pythonx.html#eval!/2"},{"type":"function","title":"Pythonx.finalize/0","doc":"","ref":"Pythonx.html#finalize/0"},{"type":"function","title":"Pythonx.initialize/0","doc":"","ref":"Pythonx.html#initialize/0"},{"type":"function","title":"Pythonx.initialize/1","doc":"Initializes the Python with the given path to `python_home`.\n\nThis function must be called before any other function in this module.\n\nIt's expected that the `python_home` is the path to the python3 directory, which contains the following\ndirectories and files:\n\n```bash\n- bin\n  - python3\n  - python3.x\n- include\n- lib\n  - python3.x\n  - libpython3.x.so (on Linux)\n  - libpython3.x.dylib (on macOS)\n```\n\nIt's also expected that this function to be called only once, and it must be called before any other function.","ref":"Pythonx.html#initialize/1"},{"type":"function","title":"Pythonx.initialize_once/1","doc":"","ref":"Pythonx.html#initialize_once/1"},{"type":"function","title":"Pythonx.inline/2","doc":"","ref":"Pythonx.html#inline/2"},{"type":"function","title":"Pythonx.inline!/2","doc":"","ref":"Pythonx.html#inline!/2"},{"type":"function","title":"Pythonx.list_python_versions/0","doc":"List all embedded python versions.","ref":"Pythonx.html#list_python_versions/0"},{"type":"macro","title":"Pythonx.pip!/2","doc":"Executes a command with the embedded pip module.","ref":"Pythonx.html#pip!/2"},{"type":"macro","title":"Pythonx.pyeval/2","doc":"Evaluates the given python code and returns the variables specified in the `return` option.","ref":"Pythonx.html#pyeval/2"},{"type":"macro","title":"Pythonx.pyinline/2","doc":"","ref":"Pythonx.html#pyinline/2"},{"type":"macro","title":"Pythonx.python3!/2","doc":"Executes a command with the embedded python3 executable.","ref":"Pythonx.html#python3!/2"},{"type":"function","title":"Pythonx.python3_executable/0","doc":"Returns the path to the python3 executable.","ref":"Pythonx.html#python3_executable/0"},{"type":"function","title":"Pythonx.python_home/0","doc":"Returns the value for `PYTHONHOME`.","ref":"Pythonx.html#python_home/0"},{"type":"module","title":"Pythonx.C.PyDict","doc":"This subtype of PyObject represents a Python dictionary object.","ref":"Pythonx.C.PyDict.html"},{"type":"function","title":"Pythonx.C.PyDict.check/1","doc":"Return `true` if `p` is a dict object or an instance of a subtype of the dict type.\n\nThis function always succeeds.","ref":"Pythonx.C.PyDict.html#check/1"},{"type":"function","title":"Pythonx.C.PyDict.check_exact/1","doc":"Return `true` if `p` is a dict object, but not an instance of a subtype of the dict type.\n\nThis function always succeeds.","ref":"Pythonx.C.PyDict.html#check_exact/1"},{"type":"function","title":"Pythonx.C.PyDict.clear/1","doc":"Empty an existing dictionary of all key-value pairs.","ref":"Pythonx.C.PyDict.html#clear/1"},{"type":"function","title":"Pythonx.C.PyDict.contains/2","doc":"Determine if dictionary `p` contains `key`. If an item in p is matches key, return `true`, otherwise return `false`.\n\nOn error, return `PyErr.t()`.\n\nThis is equivalent to the Python expression `key in p`.","ref":"Pythonx.C.PyDict.html#contains/2"},{"type":"function","title":"Pythonx.C.PyDict.copy/1","doc":"Return a new dictionary that contains the same key-value pairs as `p`.\n\nReturn value: New reference.","ref":"Pythonx.C.PyDict.html#copy/1"},{"type":"function","title":"Pythonx.C.PyDict.del_item/2","doc":"Remove the entry in dictionary `p` with key `key`.\n\n`key` must be hashable; if it isn’t, `PyErr.t()` with `TypeError` will be returned.\n\nIf `key` is not in the dictionary, `PyErr.t()` with `KeyError` will be returned.\n\nReturn `true` on success or `PyErr.t()` on failure.","ref":"Pythonx.C.PyDict.html#del_item/2"},{"type":"function","title":"Pythonx.C.PyDict.del_item_string/2","doc":"This is the same as `PyDict.del_item/2`, but `key` is specified as a UTF-8 encoded binary string, rather than a `PyObject*`.","ref":"Pythonx.C.PyDict.html#del_item_string/2"},{"type":"function","title":"Pythonx.C.PyDict.get_item/2","doc":"Return the object from dictionary `p` which has a key `key`.\n\nReturn `nil` if the key `key` is not present, but without setting an exception.","ref":"Pythonx.C.PyDict.html#get_item/2"},{"type":"function","title":"Note - Pythonx.C.PyDict.get_item/2","doc":"Exceptions that occur while this calls `__hash__()` and `__eq__()` methods are silently ignored.\n\nPrefer the `PyDict.get_item_with_error` function instead.","ref":"Pythonx.C.PyDict.html#get_item/2-note"},{"type":"function","title":"Warning - Pythonx.C.PyDict.get_item/2","doc":"Changed in version 3.10:\n\nCalling this API without GIL held had been allowed for historical reason. It is no longer allowed.\n\nReturn value: Borrowed reference","ref":"Pythonx.C.PyDict.html#get_item/2-warning"},{"type":"function","title":"Pythonx.C.PyDict.get_item_string/2","doc":"This is the same as `PyDict.get_item/2`, but `key` is specified as a UTF-8 encoded binary string, rather than a `PyObject*`.","ref":"Pythonx.C.PyDict.html#get_item_string/2"},{"type":"function","title":"Note - Pythonx.C.PyDict.get_item_string/2","doc":"Exceptions that occur while this calls `__hash__()` and `__eq__()` methods or while creating the temporary `str` object are silently ignored.\n\nPrefer using the `PyDict.get_item_with_error/2` function with your own `PyUnicode.from_string/1` `key` instead.","ref":"Pythonx.C.PyDict.html#get_item_string/2-note"},{"type":"function","title":"Pythonx.C.PyDict.get_item_with_error/2","doc":"Variant of `PyDict.get_item/2`() that does not suppress exceptions.\n\nReturn `PyErr.t()` with an exception set if an exception occurred.\n\nReturn `nil` without an exception set if the key wasn’t present.\n\nReturn value: Borrowed reference","ref":"Pythonx.C.PyDict.html#get_item_with_error/2"},{"type":"function","title":"Pythonx.C.PyDict.items/1","doc":"Return a PyListObject containing all the items from the dictionary.\n\nReturn value: New reference.","ref":"Pythonx.C.PyDict.html#items/1"},{"type":"function","title":"Pythonx.C.PyDict.keys/1","doc":"Return a PyListObject containing all the keys from the dictionary.\n\nReturn value: New reference.","ref":"Pythonx.C.PyDict.html#keys/1"},{"type":"function","title":"Pythonx.C.PyDict.merge/3","doc":"Iterate over mapping object `b` adding key-value pairs to dictionary `a`.\n\n`b` may be a dictionary, or any object supporting `PyMapping.keys/1` and `PyObject.get_item/2`.\n\nIf `override` is true, existing pairs in `a` will be replaced if a matching key is found in `b`,\notherwise pairs will only be added if there is not a matching key in `a`.\n\nReturn `:ok` on success or `PyErr.t()` with an exception.","ref":"Pythonx.C.PyDict.html#merge/3"},{"type":"function","title":"Pythonx.C.PyDict.merge_from_seq2/3","doc":"Update or merge into dictionary `a`, from the key-value pairs in `seq2`.\n\n`seq2` must be an iterable object producing iterable objects of length 2, viewed as key-value pairs.\n\nIn case of duplicate keys, the last wins if `override` is true, else the first wins.\n\nReturn `:ok` on success or `PyErr.t()` with an exception.\n\nEquivalent Python (except for the return value):\n\n```python\ndef PyDict_MergeFromSeq2(a, seq2, override):\n  for key, value in seq2:\n      if override or key not in a:\n          a[key] = value\n```","ref":"Pythonx.C.PyDict.html#merge_from_seq2/3"},{"type":"function","title":"Pythonx.C.PyDict.new/0","doc":"Return a new empty dictionary, or `PyErr` on failure.\n\nReturn value: New reference.","ref":"Pythonx.C.PyDict.html#new/0"},{"type":"function","title":"Pythonx.C.PyDict.set_default/3","doc":"This is the same as the Python-level `dict.setdefault()`.\n\nIf present, it returns the value corresponding to `key` from the dictionary `p`.\n\nIf the key is not in the dict, it is inserted with value `defaultobj` and `defaultobj` is returned.\n\nThis function evaluates the hash function of key only once, instead of evaluating it independently for the lookup and the insertion.\n\nReturn value: Borrowed reference.","ref":"Pythonx.C.PyDict.html#set_default/3"},{"type":"function","title":"Pythonx.C.PyDict.set_item/3","doc":"Insert `val` into the dictionary `p` with a key of `key`.\n\n`key` must be hashable; if it isn’t, `PyErr.t()` with `TypeError` will be returned.\n\nReturn `:ok` on success or `PyErr.t()` on failure.\n\nThis function does not steal a reference to `val`.","ref":"Pythonx.C.PyDict.html#set_item/3"},{"type":"function","title":"Pythonx.C.PyDict.set_item_string/3","doc":"This is the same as `PyDict.set_item/3`, but `key` is specified as a UTF-8 encoded binary string, rather than a `PyObject*`.","ref":"Pythonx.C.PyDict.html#set_item_string/3"},{"type":"function","title":"Pythonx.C.PyDict.size/1","doc":"Return the number of items in the dictionary.\n\nThis is equivalent to `len(p)` on a dictionary.","ref":"Pythonx.C.PyDict.html#size/1"},{"type":"function","title":"Pythonx.C.PyDict.update/2","doc":"This is the same as `PyDict.merge(a, b, true)`, and is similar to `a.update(b)` in Python except\nthat `PyDict.update/2` doesn’t fall back to the iterating over a sequence of key value pairs if\nthe second argument has no “keys” attribute.\n\nReturn `:ok` on success or `PyErr.t()` with an exception.","ref":"Pythonx.C.PyDict.html#update/2"},{"type":"function","title":"Pythonx.C.PyDict.values/1","doc":"Return a PyListObject containing all the values from the dictionary p.\n\nReturn value: New reference.","ref":"Pythonx.C.PyDict.html#values/1"},{"type":"module","title":"Pythonx.C.PyErr","doc":"Python Exception","ref":"Pythonx.C.PyErr.html"},{"type":"type","title":"Pythonx.C.PyErr.t/0","doc":"","ref":"Pythonx.C.PyErr.html#t:t/0"},{"type":"module","title":"Pythonx.C.PyEval","doc":"Python Exception","ref":"Pythonx.C.PyEval.html"},{"type":"function","title":"Pythonx.C.PyEval.get_builtins/0","doc":"Return a dictionary of the builtins in the current execution frame,\nor the interpreter of the thread state if no frame is currently executing.\n\nReturn value: Borrowed reference.","ref":"Pythonx.C.PyEval.html#get_builtins/0"},{"type":"function","title":"Pythonx.C.PyEval.get_func_desc/1","doc":"Return a description string, depending on the type of `func`.\n\nReturn values include “()” for functions and methods, “ constructor”, “ instance”, and “ object”.\n\nConcatenated with the result of `PyEval.get_func_name/1`, the result will be a description of `func`.","ref":"Pythonx.C.PyEval.html#get_func_desc/1"},{"type":"function","title":"Pythonx.C.PyEval.get_func_name/1","doc":"Return the name of `func` if it is a function, class or instance object, else the name of `funcs` type.","ref":"Pythonx.C.PyEval.html#get_func_name/1"},{"type":"function","title":"Pythonx.C.PyEval.get_globals/0","doc":"Return a dictionary of the global variables in the current execution frame, or `nil` if no frame is currently executing.\n\nReturn value: Borrowed reference.","ref":"Pythonx.C.PyEval.html#get_globals/0"},{"type":"function","title":"Pythonx.C.PyEval.get_locals/0","doc":"Return a dictionary of the local variables in the current execution frame, or `nil` if no frame is currently executing.\n\nReturn value: Borrowed reference.","ref":"Pythonx.C.PyEval.html#get_locals/0"},{"type":"module","title":"Pythonx.C.PyList","doc":"This subtype of PyObject represents a Python list object.","ref":"Pythonx.C.PyList.html"},{"type":"function","title":"Pythonx.C.PyList.append/2","doc":"Append the object item at the end of list list.\n\nReturn true if successful; return `PyErr` with an exception if unsuccessful.\n\nAnalogous to list.append(item).","ref":"Pythonx.C.PyList.html#append/2"},{"type":"function","title":"Pythonx.C.PyList.as_tuple/1","doc":"Return a new tuple object containing the contents of `list`;\n\nequivalent to `tuple(list)`.\n\nReturn value: New reference","ref":"Pythonx.C.PyList.html#as_tuple/1"},{"type":"function","title":"Pythonx.C.PyList.check/1","doc":"Return true if `p` is a list object or an instance of a subtype of the list type.\n\nThis function always succeeds.","ref":"Pythonx.C.PyList.html#check/1"},{"type":"function","title":"Pythonx.C.PyList.check_exact/1","doc":"Return true if `p` is a list object, but not an instance of a subtype of the list type.\n\nThis function always succeeds.","ref":"Pythonx.C.PyList.html#check_exact/1"},{"type":"function","title":"Pythonx.C.PyList.get_item/2","doc":"Return the object at position index in the list pointed to by list.\n\nThe position must be non-negative; indexing from the end of the list is not supported.\n\nIf index is out of bounds (<0 or >=len(list)), return `PyErr`\n\nReturn value: Borrowed reference.","ref":"Pythonx.C.PyList.html#get_item/2"},{"type":"function","title":"Pythonx.C.PyList.get_slice/3","doc":"Return a list of the objects in `list` containing the objects between `low` and `high`.\n\nReturn `PyErr` with an exception if unsuccessful.\n\nAnalogous to `list[low:high]`.\n\nIndexing from the end of the list is not supported.\n\nReturn value: New reference.","ref":"Pythonx.C.PyList.html#get_slice/3"},{"type":"function","title":"Pythonx.C.PyList.insert/3","doc":"Insert the item item into list `list` in front of index index.\n\nReturn `true` if successful; return `PyErr` with an exception if unsuccessful.\n\nAnalogous to list.insert(index, item).","ref":"Pythonx.C.PyList.html#insert/3"},{"type":"function","title":"Pythonx.C.PyList.new/1","doc":"Return a new list of length len on success, or `PyErr` on failure.","ref":"Pythonx.C.PyList.html#new/1"},{"type":"function","title":"Note - Pythonx.C.PyList.new/1","doc":"If len is greater than zero, the returned list object’s items are set to NULL.\nThus you cannot use abstract API functions such as PySequence_SetItem() or expose\nthe object to Python code before setting all items to a real object with PyList_SetItem().\n\nReturn value: New reference.","ref":"Pythonx.C.PyList.html#new/1-note"},{"type":"function","title":"Pythonx.C.PyList.reverse/1","doc":"Reverse the items of list in place.\n\nReturn `true` on success, `false` on failure.\n\nThis is equivalent to `list.reverse()`.","ref":"Pythonx.C.PyList.html#reverse/1"},{"type":"function","title":"Pythonx.C.PyList.set_item/3","doc":"Set the item at index index in list to item. Return `true` on success.\n\nIf index is out of bounds, return `PyErr` with an `IndexError` exception.\n\nNote: This function \"steals\" a reference to item and discards a reference\nto an item already in the list at the affected position.","ref":"Pythonx.C.PyList.html#set_item/3"},{"type":"function","title":"Pythonx.C.PyList.set_slice/4","doc":"Set the slice of `list` between `low` and `high` to the contents of `itemlist`.\n\nAnalogous to `list[low:high] = itemlist`.\n\nThe `itemlist` may be `nil`, indicating the assignment of an empty list (slice deletion).\n\nReturn `true` on success, `false` on failure.\n\nIndexing from the end of the list is not supported.","ref":"Pythonx.C.PyList.html#set_slice/4"},{"type":"function","title":"Pythonx.C.PyList.size/1","doc":"Return the length of the list object in list; this is equivalent to len(list) on a list object.","ref":"Pythonx.C.PyList.html#size/1"},{"type":"function","title":"Pythonx.C.PyList.sort/1","doc":"Sort the items of list in place.\n\nReturn `true` on success, `false` on failure.\n\nThis is equivalent to `list.sort()`.","ref":"Pythonx.C.PyList.html#sort/1"},{"type":"module","title":"Pythonx.C.PyLong","doc":"All integers are implemented as `PyLong.t()` integer objects of arbitrary size.","ref":"Pythonx.C.PyLong.html"},{"type":"function","title":"Pythonx.C.PyLong.as_double/1","doc":"Return a C `double` representation of `pylong`. `pylong` must be an instance of PyLongObject.\n\nReturn `PyErr.t()` with `OverflowError` if the value of `pylong` is out of range for a `double`.\n\nIf any other exception occurs returns `PyErr.t()`.","ref":"Pythonx.C.PyLong.html#as_double/1"},{"type":"function","title":"Pythonx.C.PyLong.as_long/1","doc":"Return a C `long` representation of obj.\n\nIf `obj` is not an instance of PyLongObject, first call its `__index__()` method (if present) to convert it to a PyLongObject.\n\nReturns a `PyErr.t()` with an `OverflowError` if the value of `obj` is out of range for a `long`.","ref":"Pythonx.C.PyLong.html#as_long/1"},{"type":"function","title":"Pythonx.C.PyLong.as_long_and_overflow/1","doc":"Return a C `long` representation of obj.\n\nIf `obj` is not an instance of PyLongObject, first call its `__index__()` method (if present) to convert it to a PyLongObject.\n\nIf the value of `obj` is greater than `LONG_MAX` or less than `LONG_MIN`, returns `{-1, 1}` as `{-1, -1}`, respectively,\notherwise, the second element is set to `0`.\n\nIf any other exception occurs returns `PyErr.t()`.","ref":"Pythonx.C.PyLong.html#as_long_and_overflow/1"},{"type":"function","title":"Pythonx.C.PyLong.as_long_long/1","doc":"Return a C `long long` representation of `obj`.\n\nIf `obj` is not an instance of PyLongObject, first call its `__index__()` method (if present) to convert it to a PyLongObject.\n\nReturns `PyErr.t()` with `OverflowError` if the value of `obj` is out of range for a `long long`.","ref":"Pythonx.C.PyLong.html#as_long_long/1"},{"type":"function","title":"Pythonx.C.PyLong.as_long_long_and_overflow/1","doc":"Return a C `long long` representation of `obj`.\n\nIf `obj` is not an instance of PyLongObject, first call its `__index__()` method (if present) to convert it to a PyLongObject.\n\nIf the value of `obj` is greater than `LLONG_MAX` or less than `LLONG_MIN`, , returns `{-1, 1}` as `{-1, -1}`, respectively,\n\nIf any other exception occurs returns `PyErr.t()`.","ref":"Pythonx.C.PyLong.html#as_long_long_and_overflow/1"},{"type":"function","title":"Pythonx.C.PyLong.as_size_t/1","doc":"Return a C `size_t` representation of `pylong`. `pylong` must be an instance of PyLongObject.\n\nReturn `PyErr.t()` with `OverflowError` if the value of `pylong` is out of range for a `size_t`.\n\nIf any other exception occurs returns `PyErr.t()`.","ref":"Pythonx.C.PyLong.html#as_size_t/1"},{"type":"function","title":"Pythonx.C.PyLong.as_ssize_t/1","doc":"Return a C `Py_ssize_t` representation of `pylong`. `pylong` must be an instance of PyLongObject.\n\nReturn `PyErr.t()` with `OverflowError` if the value of `pylong` is out of range for a `Py_ssize_t`.\n\nIf any other exception occurs returns `PyErr.t()`.","ref":"Pythonx.C.PyLong.html#as_ssize_t/1"},{"type":"function","title":"Pythonx.C.PyLong.as_unsigned_long/1","doc":"Return a C `unsigned long` representation of `pylong`. `pylong` must be an instance of PyLongObject.\n\nReturn `PyErr.t()` with `OverflowError` if the value of `pylong` is out of range for a `unsigned long`.\n\nIf any other exception occurs returns `PyErr.t()`.","ref":"Pythonx.C.PyLong.html#as_unsigned_long/1"},{"type":"function","title":"Pythonx.C.PyLong.as_unsigned_long_long/1","doc":"Return a C `unsigned long long` representation of `pylong`. `pylong` must be an instance of PyLongObject.\n\nReturn `PyErr.t()` with `OverflowError` if the value of `pylong` is out of range for a `unsigned long long`.\n\nIf any other exception occurs returns `PyErr.t()`.","ref":"Pythonx.C.PyLong.html#as_unsigned_long_long/1"},{"type":"function","title":"Pythonx.C.PyLong.as_unsigned_long_long_mask/1","doc":"Return a C `unsigned long long` representation of `pylong`. `pylong` must be an instance of PyLongObject.\n\nIf the value of `obj` is out of range for an `unsigned long long`, return the reduction of that value modulo `ULLONG_MAX + 1`.\n\nIf any other exception occurs returns `PyErr.t()`.","ref":"Pythonx.C.PyLong.html#as_unsigned_long_long_mask/1"},{"type":"function","title":"Pythonx.C.PyLong.as_unsigned_long_mask/1","doc":"Return a C `unsigned long` representation of `pylong`. `pylong` must be an instance of PyLongObject.\n\nIf the value of `obj` is out of range for an `unsigned long`, return the reduction of that value modulo `ULONG_MAX + 1`.\n\nIf any other exception occurs returns `PyErr.t()`.","ref":"Pythonx.C.PyLong.html#as_unsigned_long_mask/1"},{"type":"function","title":"Pythonx.C.PyLong.check/1","doc":"Return `true` if its argument is a PyLongObject or a subtype of PyLongObject.\n\nThis function always succeeds.","ref":"Pythonx.C.PyLong.html#check/1"},{"type":"function","title":"Pythonx.C.PyLong.check_exact/1","doc":"Return `true` if its argument is a PyLongObject, but not a subtype of PyLongObject.\n\nThis function always succeeds.","ref":"Pythonx.C.PyLong.html#check_exact/1"},{"type":"function","title":"Pythonx.C.PyLong.from_double/1","doc":"Return a new PyLongObject object from the integer part of `v`, or `nil` on failure.\n\nReturn value: New reference.","ref":"Pythonx.C.PyLong.html#from_double/1"},{"type":"function","title":"Pythonx.C.PyLong.from_long/1","doc":"Return a new PyLongObject object from `v`, or `nil` on failure.\n\nThe current Python implementation keeps an array of integer objects for all integers between `-5` and `256`.\nWhen you create an int in that range you actually just get back a reference to the existing object.\n\nReturn value: New reference.","ref":"Pythonx.C.PyLong.html#from_long/1"},{"type":"function","title":"Pythonx.C.PyLong.from_long_long/1","doc":"Return a new PyLongObject object from a C `long long`, or `nil` on failure.\n\nReturn value: New reference.","ref":"Pythonx.C.PyLong.html#from_long_long/1"},{"type":"function","title":"Pythonx.C.PyLong.from_size_t/1","doc":"Return a new PyLongObject object from a C `size_t`, or `nil` on failure.\n\nReturn value: New reference.","ref":"Pythonx.C.PyLong.html#from_size_t/1"},{"type":"function","title":"Pythonx.C.PyLong.from_ssize_t/1","doc":"Return a new PyLongObject object from a C `Py_ssize_t`, or `nil` on failure.\n\nReturn value: New reference.","ref":"Pythonx.C.PyLong.html#from_ssize_t/1"},{"type":"function","title":"Pythonx.C.PyLong.from_string/2","doc":"Return a new PyLongObject based on the string value in `str`, which is interpreted according to the radix in `base`,\nor `nil` on failure.\n\nIf `base` is 0, `str` is interpreted using the Integer literals definition; in this case, leading zeros in a non-zero\ndecimal number raises a `ValueError`.\n\nIf `base` is not 0, it must be between `2` and `36`, inclusive. Leading and trailing whitespace and single underscores\nafter a base specifier and between digits are ignored.\n\nIf there are no digits or str is not NULL-terminated following the digits and trailing whitespace, `ValueError` will be raised.\n\nReturn value: New reference.","ref":"Pythonx.C.PyLong.html#from_string/2"},{"type":"function","title":"Pythonx.C.PyLong.from_unsigned_long/1","doc":"Return a new PyLongObject object from a C `unsigned long`, or `nil` on failure.\n\nReturn value: New reference.","ref":"Pythonx.C.PyLong.html#from_unsigned_long/1"},{"type":"function","title":"Pythonx.C.PyLong.from_unsigned_long_long/1","doc":"Return a new PyLongObject object from a C `unsigned long long`, or `nil` on failure.\n\nReturn value: New reference.","ref":"Pythonx.C.PyLong.html#from_unsigned_long_long/1"},{"type":"function","title":"Pythonx.C.PyLong.get_info/0","doc":"On success, return a read only named tuple, that holds information about Python’s internal representation of integers.\nSee `sys.int_info` for description of individual fields.\n\nOn failure, return `PyErr.t()` with an exception set.","ref":"Pythonx.C.PyLong.html#get_info/0"},{"type":"module","title":"Pythonx.C.PyObject","doc":"Python Object","ref":"Pythonx.C.PyObject.html"},{"type":"function","title":"Pythonx.C.PyObject.ascii/1","doc":"As `repr/1`, compute a string representation of reference `o`,\nbut escape the non-ASCII characters in the string returned by `repr/1`\nwith `\\x`, `\\u` or `\\U` escapes.\n\nThis generates a string similar to that returned by `PyObject_Repr()` in Python 2.\nCalled by the `ascii()` built-in function.","ref":"Pythonx.C.PyObject.html#ascii/1"},{"type":"function","title":"Returns - Pythonx.C.PyObject.ascii/1","doc":"- reference to a new string representation object on success,\n- `PyErr` on failure,\n- `:error` only when it cannot allocate NIF resource for the object, for example, if the system is out of memory.","ref":"Pythonx.C.PyObject.html#ascii/1-returns"},{"type":"function","title":"Pythonx.C.PyObject.bytes/1","doc":"Compute a bytes representation of reference `o`.\n\nThis is the equivalent of the Python expression `bytes(o)`, when `o` is not an integer.\n\nUnlike `bytes(o)`, a `TypeError` is raised when `o` is an integer instead of a\nzero-initialized bytes object.","ref":"Pythonx.C.PyObject.html#bytes/1"},{"type":"function","title":"Returns - Pythonx.C.PyObject.bytes/1","doc":"- reference to a new bytes representation object on success,\n- `PyErr` on failure,\n- `:error` only when it cannot allocate NIF resource for the object, for example, if the system is out of memory.","ref":"Pythonx.C.PyObject.html#bytes/1-returns"},{"type":"function","title":"Pythonx.C.PyObject.decref/1","doc":"decrements the reference count for the object.","ref":"Pythonx.C.PyObject.html#decref/1"},{"type":"function","title":"Pythonx.C.PyObject.del_attr/2","doc":"Delete attribute named `attr_name`, for object `o`.\n\nReturns `false` on failure. This is the equivalent of the Python statement `del o.attr_name`.","ref":"Pythonx.C.PyObject.html#del_attr/2"},{"type":"function","title":"Pythonx.C.PyObject.del_attr_string/2","doc":"This is the same as `del_attr/2`, but `attr_name` is specified as a UTF-8 encoded bytes string, rather than a `PyObject`.","ref":"Pythonx.C.PyObject.html#del_attr_string/2"},{"type":"function","title":"Pythonx.C.PyObject.generic_get_attr/2","doc":"Generic attribute getter function that is meant to be put into a type object’s `tp_getattro` slot.\n\nIt looks for a descriptor in the dictionary of classes in the object’s MRO as well as an attribute in the object’s\n`__dict__` (if present). As outlined in Implementing Descriptors, data descriptors take preference over instance\nattributes, while non-data descriptors don’t. Otherwise, an `AttributeError` is raised.\n\nOnly returns `:error` if it cannot allocate NIF resource for the object,\nfor example, if the system is out of memory.","ref":"Pythonx.C.PyObject.html#generic_get_attr/2"},{"type":"function","title":"Pythonx.C.PyObject.generic_set_attr/3","doc":"Generic attribute setter and deleter function that is meant to be put into a type object’s `tp_setattro` slot.\n\nIt looks for a data descriptor in the dictionary of classes in the object’s MRO, and if found it takes\npreference over setting or deleting the attribute in the instance dictionary. Otherwise, the attribute is set\nor deleted in the object’s `__dict__` (if present).\n\nOn success, `true` is returned, otherwise an `AttributeError` is raised and `PyErr` is returned.","ref":"Pythonx.C.PyObject.html#generic_set_attr/3"},{"type":"function","title":"Pythonx.C.PyObject.get_attr/2","doc":"Retrieve an attribute named `attr_name` from object `o`.\n\nReturns the attribute value on success, or `nil` on failure.\n\nOnly returns `:error` if it cannot allocate NIF resource for the object,\nfor example, if the system is out of memory.\n\nThis is the equivalent of the Python expression `o.attr_name`.","ref":"Pythonx.C.PyObject.html#get_attr/2"},{"type":"function","title":"Pythonx.C.PyObject.get_attr_string/2","doc":"This is the same as `get_attr/2`, but `attr_name` is specified as a UTF-8 encoded bytes string, rather than a `PyObject`.","ref":"Pythonx.C.PyObject.html#get_attr_string/2"},{"type":"function","title":"Pythonx.C.PyObject.has_attr/2","doc":"Returns true if o has the attribute attr_name, and false otherwise.\n\nThis is equivalent to the Python expression hasattr(o, attr_name). This function always succeeds.","ref":"Pythonx.C.PyObject.html#has_attr/2"},{"type":"function","title":"Pythonx.C.PyObject.has_attr_string/2","doc":"This is the same as `has_attr/2`, but `attr_name` is specified as a UTF-8 encoded bytes string, rather than a `PyObject`.","ref":"Pythonx.C.PyObject.html#has_attr_string/2"},{"type":"function","title":"Pythonx.C.PyObject.incref/1","doc":"Increments the reference count for the object.","ref":"Pythonx.C.PyObject.html#incref/1"},{"type":"function","title":"Pythonx.C.PyObject.is_true/1","doc":"Returns `true` if the object `o` is considered to be `true`, and `false` otherwise.\n\nThis is equivalent to the Python expression `not not o`. On failure, return `:error`.","ref":"Pythonx.C.PyObject.html#is_true/1"},{"type":"function","title":"Pythonx.C.PyObject.length/1","doc":"Return the length of object `o`. If the object `o` provides either the sequence\nand mapping protocols, the sequence length is returned.\n\nOn error, `-1` is returned.\n\nThis is the equivalent to the Python expression `len(o)`.","ref":"Pythonx.C.PyObject.html#length/1"},{"type":"function","title":"Pythonx.C.PyObject.not/1","doc":"Returns `false` if the object `o` is considered to be `true`, and `true` otherwise.\nThis is equivalent to the Python expression `not o`. On failure, return `:error`.","ref":"Pythonx.C.PyObject.html#not/1"},{"type":"function","title":"Pythonx.C.PyObject.py_false/0","doc":"Returns a reference to the Python False object.\n\nOnly returns `:error` if it cannot allocate NIF resource for the object,\nfor example, if the system is out of memory.","ref":"Pythonx.C.PyObject.html#py_false/0"},{"type":"function","title":"Pythonx.C.PyObject.py_none/0","doc":"Returns a reference to the Python None object.\n\nOnly returns `:error` if it cannot allocate NIF resource for the object,\nfor example, if the system is out of memory.","ref":"Pythonx.C.PyObject.html#py_none/0"},{"type":"function","title":"Pythonx.C.PyObject.py_true/0","doc":"Returns a reference to the Python True object.\n\nOnly returns `:error` if it cannot allocate NIF resource for the object,\nfor example, if the system is out of memory.","ref":"Pythonx.C.PyObject.html#py_true/0"},{"type":"function","title":"Pythonx.C.PyObject.repr/1","doc":"Compute a string representation of reference `o`.\n\nThis is the equivalent of the Python expression `repr(o)`. Called by the `repr()` built-in function.","ref":"Pythonx.C.PyObject.html#repr/1"},{"type":"function","title":"Returns - Pythonx.C.PyObject.repr/1","doc":"- reference to a new string representation object on success,\n- `PyErr` on failure,\n- `:error` only when it cannot allocate NIF resource for the object, for example, if the system is out of memory.","ref":"Pythonx.C.PyObject.html#repr/1-returns"},{"type":"function","title":"Pythonx.C.PyObject.set_attr/3","doc":"Set the value of the attribute named `attr_name`, for object `o`, to the value `v`.\n\nReturns `PyErr` on failure; return `true` on success.\n\nThis is the equivalent of the Python statement `o.attr_name = v`.\n\nIf v is `nil`, the attribute is deleted. This behaviour is deprecated in favour of using `del_attr/2`,\nbut there are currently no plans to remove it.","ref":"Pythonx.C.PyObject.html#set_attr/3"},{"type":"function","title":"Pythonx.C.PyObject.set_attr_string/3","doc":"This is the same as `set_attr/3`, but `attr_name` is specified as a UTF-8 encoded bytes string, rather than a PyObject*.\n\nReturns `PyErr` on failure; return `true` on success.\n\nThis is the equivalent of the Python statement `o.attr_name = v`.\n\nIf v is `nil`, the attribute is deleted. This behaviour is deprecated in favour of using `del_attr/2`,\nbut there are currently no plans to remove it.","ref":"Pythonx.C.PyObject.html#set_attr_string/3"},{"type":"function","title":"Pythonx.C.PyObject.str/1","doc":"Compute a string representation of reference `o`.\n\nThis is the equivalent of the Python expression str(o). Called by the `str()` built-in function and,\ntherefore, by the `print()` function.","ref":"Pythonx.C.PyObject.html#str/1"},{"type":"function","title":"Returns - Pythonx.C.PyObject.str/1","doc":"- reference to a new string representation object on success,\n- `PyErr` on failure,\n- `:error` only when it cannot allocate NIF resource for the object, for example, if the system is out of memory.","ref":"Pythonx.C.PyObject.html#str/1-returns"},{"type":"function","title":"Pythonx.C.PyObject.type/1","doc":"Returns a type object corresponding to the object type of object `o`.\n\nWhen `o` is non-`NULL`, returns a type object corresponding to the object\ntype of object `o`.\n\nOn failure, returns `PyErr` with `SystemError`. This is equivalent to the Python expression `type(o)`.\n\nThis function creates a new strong reference to the return value.\n\nThere’s really no reason to use this function instead of the `Pythonx.C.type/1` function, which returns\na pointer of type `PyTypeObject*`, except when a new strong reference is needed.\n\nOnly returns `:error` if it cannot allocate NIF resource for the object,\nfor example, if the system is out of memory.","ref":"Pythonx.C.PyObject.html#type/1"},{"type":"type","title":"Pythonx.C.PyObject.borrowed/0","doc":"","ref":"Pythonx.C.PyObject.html#t:borrowed/0"},{"type":"type","title":"Pythonx.C.PyObject.t/0","doc":"","ref":"Pythonx.C.PyObject.html#t:t/0"},{"type":"module","title":"Pythonx.C.PyRun","doc":"The functions in this chapter will let you execute Python source code given in a file or a buffer,\nbut they will not let you interact in a more detailed way with the interpreter.\n\nSeveral of these functions accept a start symbol from the grammar as a parameter.\nThe available start symbols are `py_eval_input`, `py_file_input`, and `py_single_input`. These are described following the functions which accept them as parameters.","ref":"Pythonx.C.PyRun.html"},{"type":"function","title":"Pythonx.C.PyRun.string/4","doc":"This is a simplified interface to `PyRun.string_flags/5` below, leaving flags set to `nil`.\n\nReturn value: New reference.","ref":"Pythonx.C.PyRun.html#string/4"},{"type":"module","title":"Pythonx.C.PyTuple","doc":"This subtype of PyObject represents a Python tuple object.","ref":"Pythonx.C.PyTuple.html"},{"type":"function","title":"Pythonx.C.PyTuple.check/1","doc":"Return `true` if `p` is a tuple object or an instance of a subtype of the tuple type.\n\nThis function always succeeds.","ref":"Pythonx.C.PyTuple.html#check/1"},{"type":"function","title":"Pythonx.C.PyTuple.check_exact/1","doc":"Return `true` if `p` is a tuple object, but not an instance of a subtype of the tuple type.\n\nThis function always succeeds.","ref":"Pythonx.C.PyTuple.html#check_exact/1"},{"type":"function","title":"Pythonx.C.PyTuple.get_item/2","doc":"Return the object at position `pos` in the tuple pointed to by `p`.\n\nIf `pos` is negative or out of bounds, return `PyErr` with an `IndexError` exception.\n\nThe returned reference is borrowed from the tuple `p` (that is: it is only valid as long\nas you hold a reference to `p`).\n\nTo get a strong reference, use `Pythonx.C.new_ref/1` or `Pythonx.C.PySequence.get_item/2`.","ref":"Pythonx.C.PyTuple.html#get_item/2"},{"type":"function","title":"Pythonx.C.PyTuple.get_slice/3","doc":"Return the slice of the tuple pointed to by `p` between `low` and `high`, or `PyErr` with an exception set on failure.\n\nThis is the equivalent of the Python expression `p[low:high]`.\n\nIndexing from the end of the tuple is not supported.","ref":"Pythonx.C.PyTuple.html#get_slice/3"},{"type":"function","title":"Pythonx.C.PyTuple.new/1","doc":"Return a new tuple object of size `len`, or `PyErr` with an exception set on failure.\n\nReturn value: New reference.","ref":"Pythonx.C.PyTuple.html#new/1"},{"type":"function","title":"Pythonx.C.PyTuple.size/1","doc":"Take a pointer to a tuple object, and return the size of that tuple. On error, return `PyErr` and with an exception set.","ref":"Pythonx.C.PyTuple.html#size/1"},{"type":"module","title":"Pythonx.C.PyUnicode","doc":"Unicode Objects","ref":"Pythonx.C.PyUnicode.html"},{"type":"function","title":"Pythonx.C.PyUnicode.as_utf8/1","doc":"Returns a reference to a Python Unicode object.","ref":"Pythonx.C.PyUnicode.html#as_utf8/1"},{"type":"function","title":"Pythonx.C.PyUnicode.from_string/1","doc":"Create a Unicode object from a UTF-8 encoded null-terminated char buffer str.","ref":"Pythonx.C.PyUnicode.html#from_string/1"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,49]}}